#!/usr/bin/python

import struct
import sys
import json
import webbrowser
import glob


def send_result(result, url):
    send_message('{"result": "%s", "url": "%s" }' % (result, url))

def send_message(message):
    
    sys.stdout.write(struct.pack('I', len(message)))
    
    sys.stdout.write(message)
    sys.stdout.flush()

def receive_message():
    
    text_length_bytes = sys.stdin.read(4)

    if len(text_length_bytes) == 0:
        return False
    
    text_length = struct.unpack('i', text_length_bytes)[0]
    
    return json.loads(sys.stdin.read(text_length).decode('utf-8'))

    
while True:
    message = receive_message()
    
    if not message:
        break

    if 'options' in message:
        try:
            f = open('data.json',) 
            data = f.read()
            send_message('{"options": %s}' % (data))
        except IOError:
            send_message('{"options": {}}')
        finally:
            f.close() 
    
    if 'url' in message:
        try:
            webbrowser.open(message['url'])
        except:
            send_result("error", message['url'])
        else:
            send_result("success", message['url'])
	
    if 'firefox_agent_status' in message:
        try:
            files = glob.glob('../MacOS/*')
            f = open(files[0],)
            data = f.read()
            send_message('{"firefox_agent_status": %i}' % ("--user-agent=" in data))
        except IOError:
            send_message('{"firefox_agent_status": 0}')
        finally:
            f.close()
    
    if 'firefox_agent_status_disable' in message:
        try:
            files = glob.glob('../MacOS/*')
            f = open(files[0],)
            data = f.read()
            data = data.replace(" --user-agent=\"Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.10; rv:75.0) Gecko/20100101 Firefox/75.0\"", "")
            b = open(files[0], "w")
            b.write(data)
            send_message('{"firefox_agent_status": 0}')
        except IOError:
            send_message('{"firefox_agent_status": 1}')
        finally:
            f.close()
            b.close()
    
    if 'firefox_agent_status_enable' in message:
        try:
            files = glob.glob('../MacOS/*')
            f = open(files[0],)
            data = f.read()
            data = data.replace("kgbgkfmajbhkbkpininmppcifhljfjnf", "kgbgkfmajbhkbkpininmppcifhljfjnf --user-agent=\"Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.10; rv:75.0) Gecko/20100101 Firefox/75.0\"")
            b = open(files[0], "w")
            b.write(data)
            send_message('{"firefox_agent_status": 1}')
        except IOError:
            send_message('{"firefox_agent_status": 0}')
        finally:
            f.close()
            b.close()
exit(0)
